//////////////////////////////////////////////////////////////////////////
// File: 	ch7a.cpp                                            	//
// Description: Demo to display rotation & scaling of a sprite		//
// Author:	gbajunkie 					  	//
// Date: 	24th June 2002                                      	//
//////////////////////////////////////////////////////////////////////////
#include "gba.h"
#include "sprite.h"
#include "dispcnt.h"
#include "block1.h"
#include "input.h"

int AgbMain()
{
	u16 loop;
	u16* temp;

        SetMode(MODE_1 | OBJ_ENABLE | OBJ_MAP_1D); //set mode 1 and enable sprites and 1d mapping

	for(loop = 0; loop < 256; loop++)
		OBJPaletteMem[loop] = block1Palette[loop];

	InitializeSprites();

        sprites[0].attribute0 = COLOR_256 | SQUARE | ROTATION_FLAG | SIZE_DOUBLE | 50;	//setup sprite info,rotation enabled & size-double
        sprites[0].attribute1 = SIZE_16 | ROTDATA(0) | 120;            //size 16x16 and x-coord and rotation data 0
        sprites[0].attribute2 = 0;                      //pointer to tile where sprite starts

	sprites[1].attribute0 = COLOR_256 | SQUARE | ROTATION_FLAG | 58;	//setup sprite info,notice NO size-double enabled
        sprites[1].attribute1 = SIZE_16 | ROTDATA(1) | 80;            //size 16x16 and x-coord and rotation data 1
        sprites[1].attribute2 = 0;                      //re-use same sprite data

	for(loop = 0; loop < 128; loop++)               //load sprite image data
       	{
       		OAMData[loop] = block1Data[loop];
       	}

        while(1)   //the main game loop
	{
		GetInput();                     //check for button presses
		RotateSprite(0, angle, zoom, zoom);  //check for updated rotation and scaling parameters and update accordingly
		RotateSprite(1, angle2, zoom, zoom);
		WaitForVsync();			//waits for the screen to stop drawing
		CopyOAM();			//Copies sprite array into OAM.
	}
}

