//////////////////////////////////////////////////////////////////////////
// File: 	ch7b.cpp                                            	//
// Description: Demo to display horizontal and vertical sprite flipping //
// Author:	gbajunkie 					  	//
// Date: 	27th June 2002                                      	//
//////////////////////////////////////////////////////////////////////////
#include "gba.h"
#include "sprite.h"
#include "dispcnt.h"
#include "palette.h"
#include "pacsprites.h"
#include "input.h"

int AgbMain()
{
	u16 loop;
	u16* temp;

        SetMode(MODE_1 | OBJ_ENABLE | OBJ_MAP_1D); //set mode 1 and enable sprites and 1d mapping

	for(loop = 0; loop < 256; loop++)
		OBJPaletteMem[loop] = palette[loop];

	InitializeSprites();

        sprites[0].attribute0 = COLOR_256 | SQUARE | 50;  //setup sprite info, 256 colour, shape and y-coord
        sprites[0].attribute1 = SIZE_16 | 106;            //size 16x16 and x-coord
        sprites[0].attribute2 = 0;                        //pointer to tile where sprite starts

        for(loop = 0; loop < 128; loop++)                 //load sprite image data
       	{
       		OAMData[loop] = pacspriteData[loop];
       	}

        while(1)   //the main game loop
	{
		GetInput();                     //check for button presses
		if(spriteflip == 1)
		{
			sprites[0].attribute1 |= HORIZONTAL_FLIP;         //flip the sprite horizontally
			spriteflip = 0;
		}
		else
			sprites[0].attribute1 &= ~HORIZONTAL_FLIP;        //back to original unflipped sprite
		if(spriteflip == 2)
		{
			sprites[0].attribute1 |= VERTICAL_FLIP;           //flip the sprite vertically
			spriteflip = 0;
		}
		else
			sprites[0].attribute1 &= ~VERTICAL_FLIP;          //back to original unflipped sprite
		WaitForVsync();			//waits for the screen to stop drawing
		CopyOAM();			//Copies sprite array into OAM.
	}
}

