//////////////////////////////////////////////////////////////////////////
// File: 	pixmanip.cpp                                           	//
// Description: A program that allows you to change the screen colour	//
// Author:	gbajunkie					  	//
// Date: 	9th January 2002                                      	//
//////////////////////////////////////////////////////////////////////////

#include "gba.h"     	//all the GBA register definitions (created by Eloist)
#include "keypad.h"   	//GBA button codes (created by Nokturn)
#include "pixmanip.h"	//includes all necessary #defines for this program

int COLOUR = 0; //used for colour changes

//Function to setup what mode you wish to use
void SetMode(u16 mode)
{
	REG_DISPCNT = mode;	//defined in gba.h
				//main display register which controls which
				//background mode you are in and what buffer
				//is currently active
}

//get input from the GBA buttons
int Get_Input()
{
	if(!((*KEYS) & KEY_A))            //press the A key
	{
	}
	else if(!((*KEYS) & KEY_B))       //press the B key
	{
	}
}

//the program entry point main() function which controls the program flow
int AgbMain()
{
	int x, y;	//loop counters
	while(1)
	{
	  u16* ScreenBuffer = (u16*)0x6000000;	//the start of video memory

	  SetMode(MODE_3 | BG2_ENABLE); //set the screen to Mode 3 and background 2

	  COLOUR = Get_Input();

	  for(x=0; x<240; x++)
	  {
	    for(y=0; y<160; y++)
	    {
	        ScreenBuffer[x+y*SCREEN_WIDTH] = RGB16_BGR(0, 31, 0); //set background fill colour (green)
	    }
	  }
	}
}//end of main()





